# Address Validation & Lookup

To complete address validation requires using 2 API's each provide a specific purpose.

1. [**Find** ](#find)- Returns a list of valid addresses based on partial or complete address information.
2. [**Retrieve** ](#retrieve)- Using the 'Find id' returns the validated and enriched address information.

**Supported Countries:** All countries including Australia and New Zealand. See our [global data coverage](https://support.loqate.com/coverage-full/).

{% hint style="info" %}
**Looking for Address by Geocode or Reverse Geocoding?** [Click here](/loqate-harmony-api/api-specification/address/address-by-geocode.md#reverse-geocode-methods)
{% endhint %}

## Find

Lookup addresses using a partial or complete address information in a single line address field.

You can do further lookup using the `id` when the `Type` of the result was not `Address`.

HTTP `POST` will only process the **first** record in the request.

## GET /rest/v2/address/find

> International addresses lookup using a single-line input address

```json
{"openapi":"3.0.1","info":{"title":"Harmony RightAddress REST API","version":"2.13.0"},"tags":[{"name":"findAddress","description":"Single-line address lookup"}],"servers":[{"url":"https://hosted.mastersoftgroup.com/harmony","description":"Generated server url"}],"security":[{"rightaddress":[]}],"components":{"securitySchemes":{"rightaddress":{"type":"http","scheme":"basic"}},"schemas":{"AddressRestResponse":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","ERROR"]},"messages":{"type":"array","items":{"type":"string"}},"payload":{"type":"array","properties":{"sourceReduced":{"type":"boolean"},"empty":{"type":"boolean"},"first":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]},"last":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}},"items":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}}}},"AddressAu":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"locality":{"type":"string"},"state":{"type":"string"},"_type":{"type":"string"}}}]},"Address":{"required":["_type"],"type":"object","properties":{"fullAddress":{"type":"string"},"country":{"type":"string"},"postcode":{"type":"string"},"subLocality":{"type":"string"},"street2":{"type":"string"},"street":{"type":"string"},"streetNumber":{"type":"string"},"postal":{"type":"string"},"postalType":{"type":"string"},"postalNumber":{"type":"string"},"buildingName":{"type":"string"},"subdwelling":{"type":"string"},"eid":{"type":"string"},"lotNumber":{"type":"string"},"flatUnitNumber":{"type":"string"},"flatUnitType":{"type":"string"},"floorLevelNumber":{"type":"string"},"floorLevelType":{"type":"string"},"streetSuffix":{"type":"string"},"streetType":{"type":"string"},"streetName":{"type":"string"},"attributes":{"type":"object","additionalProperties":{"type":"string"}},"id":{"type":"string"},"sourceOfTruth":{"type":"string"},"_type":{"type":"string"}},"discriminator":{"propertyName":"_type"}},"AddressIntl":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"district":{"type":"string"},"city":{"type":"string"},"province":{"type":"string"},"_type":{"type":"string"}}}]},"AddressNz":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"rdNumber":{"type":"string"},"deliveredTo":{"type":"string"},"townCity":{"type":"string"},"suburb":{"type":"string"},"_type":{"type":"string"}}}]},"AddressV2":{"type":"object","allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"line1":{"type":"string"},"line2":{"type":"string"},"line3":{"type":"string"},"city":{"type":"string"},"province":{"type":"string"}}}]},"InternalParsedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"}]},"ParsedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"},{"type":"object","properties":{"careOf":{"type":"string"},"exception":{"type":"string"},"unknown":{"type":"string"},"changedItems":{"type":"array","items":{"$ref":"#/components/schemas/PDPChangedItem"}}}}]},"PDPChangedItem":{"type":"object","properties":{"componentID":{"type":"string"},"actionType":{"type":"string","enum":["ADD","MODIFY","REMOVE","INFO"]},"affectedElement":{"type":"string"},"oldValue":{"type":"string"},"newValue":{"type":"string"}}},"ValidatedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"},{"type":"object","properties":{"exception":{"type":"string"}}}]},"AddressIntlV2":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressIntl"}]},"InternalParsedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"}]},"ParsedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"},{"type":"object","properties":{"careOf":{"type":"string"},"exception":{"type":"string"},"unknown":{"type":"string"},"changedItems":{"type":"array","items":{"$ref":"#/components/schemas/PDPChangedItem"}}}}]},"ValidatedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"},{"type":"object","properties":{"exception":{"type":"string"}}}]}}},"paths":{"/rest/v2/address/find":{"get":{"tags":["findAddress"],"summary":"International addresses lookup using a single-line input address","operationId":"findAddress","parameters":[{"name":"country","in":"query","required":true,"schema":{"type":"string"}},{"name":"fullAddress","in":"query","required":true,"schema":{"type":"string"}},{"name":"sourceOfTruth","in":"query","required":false,"schema":{"type":"string"}},{"name":"id","in":"query","required":false,"schema":{"type":"string"}},{"name":"featureOptions","in":"query","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddressRestResponse"}}}}}}}}}
```

## POST /rest/v2/address/find

> International addresses lookup using a single-line input address

```json
{"openapi":"3.0.1","info":{"title":"Harmony RightAddress REST API","version":"2.13.0"},"tags":[{"name":"findAddress","description":"Single-line address lookup"}],"servers":[{"url":"https://hosted.mastersoftgroup.com/harmony","description":"Generated server url"}],"security":[{"rightaddress":[]}],"components":{"securitySchemes":{"rightaddress":{"type":"http","scheme":"basic"}},"schemas":{"AddressRestRequest":{"type":"object","properties":{"payload":{"type":"array","properties":{"sourceReduced":{"type":"boolean"},"empty":{"type":"boolean"},"first":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]},"last":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}},"items":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}},"sourceOfTruth":{"type":"string","enum":["AUPAF","GNAF","AUSOTS","AUPOST","NZPAF","NZAD","CNAR","ADDRESS_EXCHANGE","RIG_AU","RIG_NZ","SENDRIGHT_SOA","RIG_AU_ID","RIG_NZ_ID","RDA","MDS","ASGS","SEIFA2011","VE_INTERNAL","VE_VERIFY","VE_ALL","CUSTOM_AU_1","CUSTOM_AU_2","CUSTOM_NZ_1","CUSTOM_NZ_2"]},"featureOptions":{"type":"object","additionalProperties":{"type":"string"}},"transactionID":{"type":"string"}},"description":"The get international geocode request body: \n- `country`: the name or ISO-2 or ISO-3 country code (case-insensitive). Most country names will be recognised but the use of the ISO country code is recommended. Example: 'GB'. \n- `fullAddress`: the location to geocode. This can be a postal code or place name. Example: '13 Westdyke Terrace, Elrick, WESTHILL, AB32 6JA'."},"AddressAu":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"locality":{"type":"string"},"state":{"type":"string"},"_type":{"type":"string"}}}]},"Address":{"required":["_type"],"type":"object","properties":{"fullAddress":{"type":"string"},"country":{"type":"string"},"postcode":{"type":"string"},"subLocality":{"type":"string"},"street2":{"type":"string"},"street":{"type":"string"},"streetNumber":{"type":"string"},"postal":{"type":"string"},"postalType":{"type":"string"},"postalNumber":{"type":"string"},"buildingName":{"type":"string"},"subdwelling":{"type":"string"},"eid":{"type":"string"},"lotNumber":{"type":"string"},"flatUnitNumber":{"type":"string"},"flatUnitType":{"type":"string"},"floorLevelNumber":{"type":"string"},"floorLevelType":{"type":"string"},"streetSuffix":{"type":"string"},"streetType":{"type":"string"},"streetName":{"type":"string"},"attributes":{"type":"object","additionalProperties":{"type":"string"}},"id":{"type":"string"},"sourceOfTruth":{"type":"string"},"_type":{"type":"string"}},"discriminator":{"propertyName":"_type"}},"AddressIntl":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"district":{"type":"string"},"city":{"type":"string"},"province":{"type":"string"},"_type":{"type":"string"}}}]},"AddressNz":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"rdNumber":{"type":"string"},"deliveredTo":{"type":"string"},"townCity":{"type":"string"},"suburb":{"type":"string"},"_type":{"type":"string"}}}]},"AddressV2":{"type":"object","allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"line1":{"type":"string"},"line2":{"type":"string"},"line3":{"type":"string"},"city":{"type":"string"},"province":{"type":"string"}}}]},"InternalParsedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"}]},"ParsedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"},{"type":"object","properties":{"careOf":{"type":"string"},"exception":{"type":"string"},"unknown":{"type":"string"},"changedItems":{"type":"array","items":{"$ref":"#/components/schemas/PDPChangedItem"}}}}]},"PDPChangedItem":{"type":"object","properties":{"componentID":{"type":"string"},"actionType":{"type":"string","enum":["ADD","MODIFY","REMOVE","INFO"]},"affectedElement":{"type":"string"},"oldValue":{"type":"string"},"newValue":{"type":"string"}}},"ValidatedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"},{"type":"object","properties":{"exception":{"type":"string"}}}]},"AddressIntlV2":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressIntl"}]},"InternalParsedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"}]},"ParsedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"},{"type":"object","properties":{"careOf":{"type":"string"},"exception":{"type":"string"},"unknown":{"type":"string"},"changedItems":{"type":"array","items":{"$ref":"#/components/schemas/PDPChangedItem"}}}}]},"ValidatedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"},{"type":"object","properties":{"exception":{"type":"string"}}}]},"AddressRestResponse":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","ERROR"]},"messages":{"type":"array","items":{"type":"string"}},"payload":{"type":"array","properties":{"sourceReduced":{"type":"boolean"},"empty":{"type":"boolean"},"first":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]},"last":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}},"items":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}}}}}},"paths":{"/rest/v2/address/find":{"post":{"tags":["findAddress"],"summary":"International addresses lookup using a single-line input address","operationId":"findAddress_1","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddressRestRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddressRestResponse"}}}}}}}}}
```

{% hint style="info" %}
**Demo available here:** [**https://www.loqate.com/anz/address-validation/**](https://www.loqate.com/anz/address-validation/)\*\*\*\*
{% endhint %}

### Resource

```
GET/POST    https://hosted.mastersoftgroup.com/harmony/rest/v2/address/find
```

### Request

The request body is an [AddressRestRequest](/loqate-harmony-api/api-specification/objects/address-objects.md#addressrestrequest) object.&#x20;

We have a large amount of use case based performance tuning that can be done.&#x20;

\*=required field

<table><thead><tr><th width="211">Name</th><th width="89">Type</th><th width="141">Example</th><th>Description</th></tr></thead><tbody><tr><td><strong>Payload</strong></td><td></td><td></td><td></td></tr><tr><td>country*</td><td>string</td><td>AU</td><td>ISO-2 or ISO-3 country</td></tr><tr><td>fullAddress*</td><td>string</td><td>10 High</td><td>partial address information entered by end users.</td></tr><tr><td>id</td><td>string</td><td>AU1235</td><td>The id from previous request indicating request from groupedAddress </td></tr><tr><td>state</td><td>string</td><td>NSW</td><td>AU &#x26; NZ only. Filters to address response to the state</td></tr><tr><td>locality</td><td>string</td><td>Sydney CBD</td><td>AU &#x26; NZ only. Filters to address response to the locality. Often used with strictValidation = 0.</td></tr><tr><td>postcode</td><td>string</td><td>2000</td><td>AU &#x26; NZ only. Filters to address response to the postcode. Often used with strictValidation = 0.</td></tr><tr><td><strong>sourceOfTruth</strong></td><td></td><td></td><td></td></tr><tr><td>sourceOfTruth*</td><td>string</td><td>AUSOTS</td><td><p>Within AU &#x26; NZ specifies the desired dataset for your use case.  Options:</p><p>AUS: "AUPAF", "GNAF", "AUSOTS","AUPOST"</p><p>NZ: "NZPAF", "NZAD", "CNAR"</p></td></tr><tr><td><strong>featureOptions</strong></td><td></td><td></td><td></td></tr><tr><td>singleLineHitNumber</td><td>integer</td><td>5 <br>default 20</td><td>Maximum number of results returned from the lookup. </td></tr><tr><td>caseType</td><td>string</td><td>TITLE default UP</td><td>Case type for the returned addresses and components. LOW = lowercase, UP = UPPERCASE, TITLE = Title Case</td></tr><tr><td>moreSources</td><td>string</td><td>"AUPOST,NZAD"</td><td>Lookups additional Sources of Truth and combines results. Used in conjunction with sourceOfTruth to expand address reach.</td></tr><tr><td>displayGnafLot</td><td>string</td><td>("0"|"1") default 1</td><td>Determines if the lot information is displayed in addresses retrieved from GNAF. </td></tr><tr><td>suppressLot</td><td>string</td><td>("0"|"1") default 1</td><td>Suppresses Lot information when a street# is available in the address. If Street# is not in address then Lot information is displayed. Used when displayGnafLot = 1 and suppressLot = 1. </td></tr><tr><td>groupAddresses</td><td>string</td><td>("0"|"1") default 0</td><td>If "1", the service will try to collapse sub-dwelling addresses within the same primary address into a group to reduce clutter. Recommended for INTL addresses.</td></tr><tr><td>positionFilter</td><td>string</td><td>POSTAL ROOFTOP DOORSTOP SINGLE</td><td><p>AU Only. Default all</p><p>Array of filters to be applied to the lookup results. Used to control which addresses you have in your serviceable network.</p></td></tr><tr><td>addressTypeFilter</td><td>string</td><td>urban, box, bag, rural, counter, cmb urban, cmb rural, upl, lpo, cpa, rp, ra, rspb, cspb</td><td><p>Default all</p><p>Array of filters to be applied to the lookup results. Used to control which addresses you have in your serviceable network.</p></td></tr><tr><td>exposePhantom</td><td>string</td><td>("0"|"1") default 0</td><td>Determines whether to expose phantom addresses for AUPAF. If the flag is set to "1", it will expose phantom address. </td></tr><tr><td>baseSource</td><td>string</td><td>"GNAF" |"AUPAF" default "GNAF"</td><td>Used when SourceOfTruth is AUSOTS. Specifies which data source is used as the base for the search result. </td></tr><tr><td>prioritizedSort</td><td>string</td><td>("0"|"1") default 1</td><td>Sorts locality information based on popularity of addresses. </td></tr><tr><td>splitNzFloorLevel</td><td>string</td><td>("0"|"1") default 0</td><td><p>Used when SourceOfTruth is NZPAF.</p><p>When "1", the floor information will be splitted into "floorLevelType" and "floorLevelNumber". </p></td></tr><tr><td>userInferred</td><td>string</td><td>("0"|"1") default 0</td><td>Takes user input relating to subdwellings and inferrers this into the find results. <a href="/pages/sEPcQv5o48ddoAi3r9Gx">See our guide</a>.</td></tr></tbody></table>

### Response

The response body is an [AddressRestResponse](/loqate-harmony-api/api-specification/objects/address-objects.md#addressrestresponse) object.

{% hint style="success" %}
See [Address Field Mapping Gui](/loqate-harmony-api/guides/best-practices/address-field-mappings.md)[de](/loqate-harmony-api/guides/best-practices/address-field-mappings.md) for integration best practices.
{% endhint %}

### Examples

Our API is highly configurable for your use case. Contact us to help get guidance on optimal settings.

<details>

<summary>Find AUPAF</summary>

**Request**: lookup addresses with AUPAF Source of Truth including group addresses.

```json
    {
        "payload": [ { "country": "au", "fullAddress": "20 bond st, nsw" } ], 
        "sourceOfTruth": "AUPAF",
        "featureOptions": { "groupAddresses": "1", "singleLineHitNumber": "3" }
    }
```

Response of **Request**:

```json
    {
        "status": "SUCCESS",
        "messages": [],
        "payload": [
            {
                "_type": "AddressIntlV2",
                "fullAddress": "G 20 Bond St, Sydney NSW 2000",
                "attributes": {
                    "Type": "Floor",
                    "subdwellings": "4 Addresses"
                },
                "id": "AU|AUPAF|G3860"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "20 Bond St, Maroubra NSW 2035",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|AUPAF|48318069"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "20 Bond St, Mosman NSW 2088",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|AUPAF|79044392"
            }
        ]
    }
```

</details>

<details>

<summary>Find GNAF</summary>

**Request 1**: lookup addresses with GNAF Source of Truth including group addresses.

```json
    {
        "payload": [ { "country": "au", "fullAddress": "20 bond st, nsw" } ], 
        "sourceOfTruth": "GNAF",
        "featureOptions": { "groupAddresses": "1", "caseType": "TITLE", "singleLineHitNumber": "3" }
    }
```

Response of **Request 1**:

```json
    {
        "status": "SUCCESS",
        "messages": [],
        "payload": [
            {
                "_type": "AddressIntlV2",
                "fullAddress": "20 Bond Street, Sydney NSW 2000",
                "attributes": {
                    "Type": "BuildingNumber",
                    "subdwellings": "45 Addresses"
                },
                "id": "AU|GNAF|GANSW710271307"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "20 Bond Street, Oran Park NSW 2570",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|GNAF|GANSW718237492"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "20 Bond Lane, Ballina NSW 2478",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|GNAF|GANSW718881455"
            }
        ]
    }
```

</details>

<details>

<summary>Find GNAF with Suppress Lot</summary>

**Request 1**: lookup addresses with GNAF Source of Truth that includes address records with Lot number suppressed when Street Number exists.

* `suppressLot = 1` is the featureOption used to suppress the lot number when street number exists.&#x20;
* `displayGnafLot =1`is the featureOption that displays. 1=true. This is important for address that do not have street numbers.
* Lot number will still be displayed for the records that do not have street number. Australia only, use it with sourceOfTruth:GNAF/AUSOTS.

```json
    {
        "payload": [ { "country": "au", "fullAddress": "twentie Lot 2" } ], 
        "sourceOfTruth": "GNAF",
        "featureOptions": { "caseType": "TITLE", "singleLineHitNumber": "3","suppressLot":"1", "displayGnafLot":"1" }
    }
```

Response of **Request 1**:

```json
    {
        "status": "SUCCESS",
        "messages": [],
        "payload": [
            {
                "_type": "AddressIntlV2",
                "fullAddress": "Lot 2 Twentieth Street, Renmark SA 5341",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|GNAF|GASA_424216948"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "6 Twentieth Avenue, Brighton QLD 4017",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|GNAF|GAQLD162919174"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "8 Twentieth Avenue, Brighton QLD 4017",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|GNAF|GAQLD155074339"
            }
        ]
    }
```

**n**

</details>

<details>

<summary>Find sub-premises by using ID</summary>

**Request 1**: lookup addresses further for `BuildingNumber Type` record below with GNAF Source of Truth.

```json
    {
        "payload": [
            {
                "country": "au",
                "fullAddress": "20 bond st, nsw",
                "id": "AU|GNAF|GANSW710271307"
            }
        ],
        "sourceOfTruth": "GNAF",
        "featureOptions": { "caseType": "TITLE", "singleLineHitNumber": "3" }
    }
```

Response of **Request 1**:

```json
    {
        "status": "SUCCESS",
        "messages": [],
        "payload": [
            {
                "_type": "AddressIntlV2",
                "fullAddress": "L 1 20 Bond Street, Sydney NSW 2000",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|GNAF|GANSW717802735"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "L 2 20 Bond Street, Sydney NSW 2000",
                "attributes": {
                    "Type": "Address"
                },
                "id": "AU|GNAF|GANSW717802749"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "L 3 20 Bond Street, Sydney NSW 2000",
                "attributes": {
                    "Type": "Floor",
                    "subdwellings": "3 Addresses"
                },
                "id": "AU|GNAF|GANSW717802752"
            }
        ]
    }
```

**n**

</details>

<details>

<summary>Find NZAD</summary>

**Request 1**: lookup addresses with NZAD Source of Truth.

```json
    {
        "payload": [ { "country": "NZ", "fullAddress": "20 bond st, marton" } ], 
        "sourceOfTruth": "NZAD",
        "featureOptions": { "singleLineHitNumber": "3" }
    }
```

Response of **Request 1**:

```json
    {
        "status": "SUCCESS",
        "messages": [],
        "payload": [
            {
                "_type": "AddressIntlV2",
                "fullAddress": "20 Bond Street, Marton 4710",
                "attributes": {
                    "Type": "Address"
                },
                "id": "NZ|NZAD|1154036"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "Flat 20 30 Bond Street, Marton 4710",
                "attributes": {
                    "Type": "Address"
                },
                "id": "NZ|NZAD|1154050"
            }
        ]
    }
```

</details>

<details>

<summary>Find CNAR</summary>

**Request 1**: lookup addresses with NZAD Source of Truth.

```json
   {
        "payload": [ { "fullAddress": "10 LIVERPOOL", "country": "NZ"} ],
        "sourceOfTruth": "CNAR",
        "featureOptions":{"singleLineHitNumber":"3"}      
    }
```

Response of **Request 1**:

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntlV2",
            "fullAddress": "10 LIVERPOOL STREET, PAPAKURA, AUCKLAND 2110",
            "attributes": {
                "Type": "Address"
            },
            "id": "NZ|CNAR|13433417"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "10 LIVERPOOL STREET, EPSOM, AUCKLAND 1023",
            "attributes": {
                "Type": "Address"
            },
            "id": "NZ|CNAR|13526909"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "10 LIVERPOOL STREET, DARGAVILLE 0310",
            "attributes": {
                "Type": "Address"
            },
            "id": "NZ|CNAR|10519716"
        }
    ]
}
```

</details>

<details>

<summary>Find UK/INTL with Grouped addresses</summary>

**Request 1**: lookup UK addresses including group addresses.

```json
    {
        "payload": [ { "country": "GB", "fullAddress": "bond st" } ],
        "featureOptions": { "groupAddresses": "1", "singleLineHitNumber": "3" }
    }
```

Response of **Request 1**:

```json
    {
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Bond Street St. Helier Jersey JE2 3NP",
            "attributes": {
                "Type": "Container",
                "subdwellings": " - 44 Addresses"
            },
            "id": "gb-rm|6GF2wIoBX8V_g8REAb7E"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Bond Street Hull HU1 3EY",
            "attributes": {
                "Type": "Container",
                "subdwellings": " - 43 Addresses"
            },
            "id": "gb-rm|-GB1wIoBX8V_g8REXblr"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Bond Street Bristol BS2 9AW",
            "attributes": {
                "Type": "Container",
                "subdwellings": " - 51 Addresses"
            },
            "id": "gb-rm|5lRswIoBX8V_g8RE_gPz"
        }
    ]
}
```

</details>

<details>

<summary>Find UK/INTL with Street Type</summary>

**Request 1**: lookup UK addresses further for `Street Type` record below.

```json
    {
        "payload": [
            {
                "country": "GB",
                "fullAddress": "bond rd marton", 
                "id": "GB|RM|ENG|MANCHESTER---WAY-MANCUNIAN-ESTATE-BOND_STREET_INDUSTRIAL"
            }
        ]
    }
```

Response of **Request 1**:

```json
    {
        "status": "SUCCESS",
        "messages": [],
        "payload": [
            {
                "_type": "AddressIntlV2",
                "fullAddress": "Unit 1-2, Bond Street Industrial Estate Mancunian Way Manchester, M12 6HW",
                "attributes": {
                    "Type": "Address"
                },
                "id": "GB|RM|A|14405045"
            },
            {
                "_type": "AddressIntlV2",
                "fullAddress": "Dirt Factory, Unit 5, Bond Street Industrial Estate Mancunian Way Manchester, M12 6HW",
                "attributes": {
                    "Type": "Address"
                },
                "id": "GB|RM|A|53184843"
            }
        ]
    }
```

</details>

<details>

<summary>Find sourceOfTruth with AU Parcel Locker Plus</summary>

**Request 1**: lookup addresses with AUPAF and AUPOST Assets (All: Parcel Locker, Offices, Shops)

```json
    {
        "payload": [ { "country": "AU", "fullAddress": "parcel 3000 " } ], 
        "sourceOfTruth": "AUPAF",
        "featureOptions": { "moreSources": "AUPOST", "singleLineHitNumber": "5"}
    }
```

Response of **Request 1**:

As AUPOST is listed as moreSource the Source of Truth addresses are prioritized.

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntlV2",
            "fullAddress": "U 3000 668 BOURKE ST, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|88745091"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "CARE PO, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|43777876"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "RSD 3000, DELORAINE TAS 7304",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|31144512"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Melbourne GPO Parcel Locker, 260 Elizabeth Street, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|51097582_UPL"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "360 Collins Street Parcel Locker, 360 Collins St, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|45897528_UPL"
        }
    ]
}
```

**Request 2**: lookup addresses with AUPAF and AUPOST Assets (Filter specific Aupost assests using addressTypeFilter)

```json
    {
        "payload": [ { "fullAddress": "Kingswood", "country": "AU","state":"NSW","postcode":"2747"} ],
        "sourceOfTruth": "AUPAF",
        "featureOptions":{"caseType":"UP","moreSources":"AUPOST","singleLineHitNumber":"8","addressTypeFilter":"rspb,cspb,-rp","strictFieldValidation":"1"}
    }
```

Response of **Request 2**:

As AUPOST is listed as moreSource the Source of Truth addresses are prioritized.

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntlV2",
            "fullAddress": "1 CALLOW LANE, KINGSWOOD NSW 2747",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|82993174"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "2 CALLOW LANE, KINGSWOOD NSW 2747",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|96069249"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "12 RICHMOND RD, KINGSWOOD NSW 2747",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|94959954"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "16 RICHMOND RD, KINGSWOOD NSW 2747",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|49041044"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "RED STREET POSTING BOX, 2 RICHMOND ROAD, KINGSWOOD NSW 2747",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|RED0005682"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "COMBINED STREET POSTING BOX, 9 BRINGELLY ROAD, KINGSWOOD NSW 2747",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|RED0005670"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "RED STREET POSTING BOX, 61 DERBY STREEET, KINGSWOOD NSW 2747",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|RED0005680"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "RED STREET POSTING BOX, 42 BRINGELLY ROAD, KINGSWOOD NSW 2747",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|RED0005671"
        }
    ]
}
```

Using the `id` you can call retrieve function see Retrieve AustPost Asset

</details>

<details>

<summary>Find AU Parcel Locker Plus (Aust Post Assets)</summary>

You can apply filters depending on AustPost Asset (see [addressTypeFilter](/loqate-harmony-api/api-specification/objects/address-objects.md)). See Request 2 in this section

**Request 1**: lookup addresses with AUPOST Assets (All: Parcel Locker, Offices, Shops).&#x20;

```json
    {
        "payload": [ { "country": "AU", "fullAddress": "parcel 3000 " } ], 
        "sourceOfTruth": "AUPOST",
        "featureOptions": {"singleLineHitNumber": "5"}
    }
```

Response of **Request 1**:

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Melbourne GPO Parcel Locker, 260 Elizabeth Street, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|51097582_UPL"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "360 Collins Street Parcel Locker, 360 Collins St, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|45897528_UPL"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "452 Flinders Street Parcel Locker, 452 Flinders Street, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|35165839_UPL"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "RMIT Library Parcel Locker, 124 La Trobe Street, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|70135061_UPL"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Melbourne Bourke Street Parcel Locker, 15 Southern Cross Lane, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|95803441_UPL"
        }
    ]
}
```

Using the `id` you can call retrieve function see Retrieve AustPost Asset

**Request 2**: lookup addresses with AUPOST Assets filtering only Parcel Lockers

```json
    {
        "payload": [ { "country": "AU", "fullAddress": "3000 " } ], 
        "sourceOfTruth": "AUPOST",
        "featureOptions": {"singleLineHitNumber": "3","addressTypeFilter":"UPL"}
    }
```

Response of **Request 1**:

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Melbourne GPO Box Room Parcel Locker, 380 Bourke St, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|77153239_UPL"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "360 Collins Street Parcel Locker, 360 Collins St, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|45897528_UPL"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "452 Flinders Street Parcel Locker, 452 Flinders Street, MELBOURNE VIC 3000",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPOST|35165839_UPL"
        }
    ]
}
```

</details>

<details>

<summary>Find Derived Address</summary>

**Request 1**: lookup addresses with derived sub-premises enabled.

```json
   {
        "payload": [ { "fullAddress": "Unit 888 100 john", "country": "AU"} ],
        "sourceOfTruth": "GNAF",
        "featureOptions":{"userInferred":"1","singleLineHitNumber":"3", "suppressLot":"1", "displayGnafLot":"1"}      
    }
```

**Response to Request 1:**

<pre class="language-json"><code class="lang-json"><strong>{
</strong>    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Unit 888 100 St Johns Road, Cabramatta NSW 2166",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|GNAF|GANSW704282071|Unit 888"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Unit 1 100 Johnston Street, Newport VIC 3015",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|GNAF|GAVIC411988613"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "Unit 2 100 Johnston Street, Newport VIC 3015",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|GNAF|GAVIC411989640"
        }
    ]
}
</code></pre>

Using the `id` you can call retrieve function see [Retrieve Derived Address](#retrieve-request-10-derived-address)

</details>

<details>

<summary>Find AU &#x26; NZ multi search</summary>

**Request 1**: lookup addresses with AU & NZ within one search

```json
    {
        "payload": [ { "country": "AU", "fullAddress": "10 george " } ], 
        "sourceOfTruth": "AUPAF",
        "featureOptions": {"moreSources":"NZAD", "singleLineHitNumber": "5"  }
    }
```

Response of **Request 1**:

As AUPAF country AU is the prioritised source and this prioritises results. Both AU & NZ results are returned.

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntlV2",
            "fullAddress": "10 GEORGE CRES, CICCONE NT 0870",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|70509953"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "10 GEORGE ST, SEAFORTH QLD 4741",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|52620610"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "10 GEORGE TCE, JUNORTOUN VIC 3551",
            "attributes": {
                "Type": "Address"
            },
            "id": "AU|AUPAF|68882692"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "10 GEORGE STREET, PICTON 7220",
            "attributes": {
                "Type": "Address"
            },
            "id": "NZ|NZAD|450727"
        },
        {
            "_type": "AddressIntlV2",
            "fullAddress": "10 GEORGE STREET, BLENHEIM 7201",
            "attributes": {
                "Type": "Address"
            },
            "id": "NZ|NZAD|1592307"
        }
    ]
}
```

Using the `id` you can call retrieve function&#x20;

</details>

## Retrieve

Retrieves validated address for the supplied `id`using the [Find ](#find)method.

## GET /rest/v2/address/retrieve

> International addresses retrieve by id

```json
{"openapi":"3.0.1","info":{"title":"Harmony RightAddress REST API","version":"2.13.0"},"tags":[{"name":"retrieveAddress","description":"Address retrieve by id"}],"servers":[{"url":"https://hosted.mastersoftgroup.com/harmony","description":"Generated server url"}],"security":[{"rightaddress":[]}],"components":{"securitySchemes":{"rightaddress":{"type":"http","scheme":"basic"}},"schemas":{"AddressRestResponse":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","ERROR"]},"messages":{"type":"array","items":{"type":"string"}},"payload":{"type":"array","properties":{"sourceReduced":{"type":"boolean"},"empty":{"type":"boolean"},"first":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]},"last":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}},"items":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}}}},"AddressAu":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"locality":{"type":"string"},"state":{"type":"string"},"_type":{"type":"string"}}}]},"Address":{"required":["_type"],"type":"object","properties":{"fullAddress":{"type":"string"},"country":{"type":"string"},"postcode":{"type":"string"},"subLocality":{"type":"string"},"street2":{"type":"string"},"street":{"type":"string"},"streetNumber":{"type":"string"},"postal":{"type":"string"},"postalType":{"type":"string"},"postalNumber":{"type":"string"},"buildingName":{"type":"string"},"subdwelling":{"type":"string"},"eid":{"type":"string"},"lotNumber":{"type":"string"},"flatUnitNumber":{"type":"string"},"flatUnitType":{"type":"string"},"floorLevelNumber":{"type":"string"},"floorLevelType":{"type":"string"},"streetSuffix":{"type":"string"},"streetType":{"type":"string"},"streetName":{"type":"string"},"attributes":{"type":"object","additionalProperties":{"type":"string"}},"id":{"type":"string"},"sourceOfTruth":{"type":"string"},"_type":{"type":"string"}},"discriminator":{"propertyName":"_type"}},"AddressIntl":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"district":{"type":"string"},"city":{"type":"string"},"province":{"type":"string"},"_type":{"type":"string"}}}]},"AddressNz":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"rdNumber":{"type":"string"},"deliveredTo":{"type":"string"},"townCity":{"type":"string"},"suburb":{"type":"string"},"_type":{"type":"string"}}}]},"AddressV2":{"type":"object","allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"line1":{"type":"string"},"line2":{"type":"string"},"line3":{"type":"string"},"city":{"type":"string"},"province":{"type":"string"}}}]},"InternalParsedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"}]},"ParsedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"},{"type":"object","properties":{"careOf":{"type":"string"},"exception":{"type":"string"},"unknown":{"type":"string"},"changedItems":{"type":"array","items":{"$ref":"#/components/schemas/PDPChangedItem"}}}}]},"PDPChangedItem":{"type":"object","properties":{"componentID":{"type":"string"},"actionType":{"type":"string","enum":["ADD","MODIFY","REMOVE","INFO"]},"affectedElement":{"type":"string"},"oldValue":{"type":"string"},"newValue":{"type":"string"}}},"ValidatedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"},{"type":"object","properties":{"exception":{"type":"string"}}}]},"AddressIntlV2":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressIntl"}]},"InternalParsedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"}]},"ParsedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"},{"type":"object","properties":{"careOf":{"type":"string"},"exception":{"type":"string"},"unknown":{"type":"string"},"changedItems":{"type":"array","items":{"$ref":"#/components/schemas/PDPChangedItem"}}}}]},"ValidatedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"},{"type":"object","properties":{"exception":{"type":"string"}}}]}}},"paths":{"/rest/v2/address/retrieve":{"get":{"tags":["retrieveAddress"],"summary":"International addresses retrieve by id","operationId":"retrieveAddress","parameters":[{"name":"id","in":"query","required":true,"schema":{"type":"string"}},{"name":"featureOptions","in":"query","required":false,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddressRestResponse"}}}}}}}}}
```

## POST /rest/v2/address/retrieve

> International addresses retrieve by id

```json
{"openapi":"3.0.1","info":{"title":"Harmony RightAddress REST API","version":"2.13.0"},"tags":[{"name":"retrieveAddress","description":"Address retrieve by id"}],"servers":[{"url":"https://hosted.mastersoftgroup.com/harmony","description":"Generated server url"}],"security":[{"rightaddress":[]}],"components":{"securitySchemes":{"rightaddress":{"type":"http","scheme":"basic"}},"schemas":{"AddressRestRequest":{"type":"object","properties":{"payload":{"type":"array","properties":{"sourceReduced":{"type":"boolean"},"empty":{"type":"boolean"},"first":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]},"last":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}},"items":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}},"sourceOfTruth":{"type":"string","enum":["AUPAF","GNAF","AUSOTS","AUPOST","NZPAF","NZAD","CNAR","ADDRESS_EXCHANGE","RIG_AU","RIG_NZ","SENDRIGHT_SOA","RIG_AU_ID","RIG_NZ_ID","RDA","MDS","ASGS","SEIFA2011","VE_INTERNAL","VE_VERIFY","VE_ALL","CUSTOM_AU_1","CUSTOM_AU_2","CUSTOM_NZ_1","CUSTOM_NZ_2"]},"featureOptions":{"type":"object","additionalProperties":{"type":"string"}},"transactionID":{"type":"string"}},"description":"The get international geocode request body: \n- `country`: the name or ISO-2 or ISO-3 country code (case-insensitive). Most country names will be recognised but the use of the ISO country code is recommended. Example: 'GB'. \n- `fullAddress`: the location to geocode. This can be a postal code or place name. Example: '13 Westdyke Terrace, Elrick, WESTHILL, AB32 6JA'."},"AddressAu":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"locality":{"type":"string"},"state":{"type":"string"},"_type":{"type":"string"}}}]},"Address":{"required":["_type"],"type":"object","properties":{"fullAddress":{"type":"string"},"country":{"type":"string"},"postcode":{"type":"string"},"subLocality":{"type":"string"},"street2":{"type":"string"},"street":{"type":"string"},"streetNumber":{"type":"string"},"postal":{"type":"string"},"postalType":{"type":"string"},"postalNumber":{"type":"string"},"buildingName":{"type":"string"},"subdwelling":{"type":"string"},"eid":{"type":"string"},"lotNumber":{"type":"string"},"flatUnitNumber":{"type":"string"},"flatUnitType":{"type":"string"},"floorLevelNumber":{"type":"string"},"floorLevelType":{"type":"string"},"streetSuffix":{"type":"string"},"streetType":{"type":"string"},"streetName":{"type":"string"},"attributes":{"type":"object","additionalProperties":{"type":"string"}},"id":{"type":"string"},"sourceOfTruth":{"type":"string"},"_type":{"type":"string"}},"discriminator":{"propertyName":"_type"}},"AddressIntl":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"district":{"type":"string"},"city":{"type":"string"},"province":{"type":"string"},"_type":{"type":"string"}}}]},"AddressNz":{"required":["_type"],"type":"object","discriminator":{"propertyName":"_type"},"allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"rdNumber":{"type":"string"},"deliveredTo":{"type":"string"},"townCity":{"type":"string"},"suburb":{"type":"string"},"_type":{"type":"string"}}}]},"AddressV2":{"type":"object","allOf":[{"$ref":"#/components/schemas/Address"},{"type":"object","properties":{"line1":{"type":"string"},"line2":{"type":"string"},"line3":{"type":"string"},"city":{"type":"string"},"province":{"type":"string"}}}]},"InternalParsedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"}]},"ParsedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"},{"type":"object","properties":{"careOf":{"type":"string"},"exception":{"type":"string"},"unknown":{"type":"string"},"changedItems":{"type":"array","items":{"$ref":"#/components/schemas/PDPChangedItem"}}}}]},"PDPChangedItem":{"type":"object","properties":{"componentID":{"type":"string"},"actionType":{"type":"string","enum":["ADD","MODIFY","REMOVE","INFO"]},"affectedElement":{"type":"string"},"oldValue":{"type":"string"},"newValue":{"type":"string"}}},"ValidatedAddressAu":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressAu"},{"type":"object","properties":{"exception":{"type":"string"}}}]},"AddressIntlV2":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressIntl"}]},"InternalParsedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"}]},"ParsedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"},{"type":"object","properties":{"careOf":{"type":"string"},"exception":{"type":"string"},"unknown":{"type":"string"},"changedItems":{"type":"array","items":{"$ref":"#/components/schemas/PDPChangedItem"}}}}]},"ValidatedAddressNz":{"type":"object","allOf":[{"$ref":"#/components/schemas/AddressNz"},{"type":"object","properties":{"exception":{"type":"string"}}}]},"AddressRestResponse":{"type":"object","properties":{"status":{"type":"string","enum":["SUCCESS","ERROR"]},"messages":{"type":"array","items":{"type":"string"}},"payload":{"type":"array","properties":{"sourceReduced":{"type":"boolean"},"empty":{"type":"boolean"},"first":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]},"last":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}},"items":{"oneOf":[{"$ref":"#/components/schemas/AddressAu"},{"$ref":"#/components/schemas/AddressIntl"},{"$ref":"#/components/schemas/AddressNz"},{"$ref":"#/components/schemas/AddressV2"},{"$ref":"#/components/schemas/InternalParsedAddressAu"},{"$ref":"#/components/schemas/ParsedAddressAu"},{"$ref":"#/components/schemas/ValidatedAddressAu"},{"$ref":"#/components/schemas/AddressIntlV2"},{"$ref":"#/components/schemas/InternalParsedAddressNz"},{"$ref":"#/components/schemas/ParsedAddressNz"},{"$ref":"#/components/schemas/ValidatedAddressNz"}]}}}}}},"paths":{"/rest/v2/address/retrieve":{"post":{"tags":["retrieveAddress"],"summary":"International addresses retrieve by id","operationId":"retrieveAddress_1","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddressRestRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/AddressRestResponse"}}}}}}}}}
```

### Resource

```
    GET/POST    https://hosted.mastersoftgroup.com/harmony/rest/v2/address/retrieve
```

### Request

The request body is an [AddressRestRequest ](/loqate-harmony-api/api-specification/objects/address-objects.md#addressrestrequest)object:

\*=required field

<table><thead><tr><th>Name</th><th width="92">Type</th><th width="121">Example</th><th>Description</th></tr></thead><tbody><tr><td><strong>payload</strong></td><td></td><td></td><td></td></tr><tr><td>id*</td><td>string</td><td>"AU|GNAF|GANSW705038278"</td><td>ID given within the payload of the Find API response.</td></tr><tr><td><strong>featureOptions</strong></td><td></td><td></td><td></td></tr><tr><td>caseType</td><td>string</td><td>"TITLE"<br>default UP</td><td>Case type for the returned addresses and components. LOW = lowercase, UP = UPPERCASE, TITLE = Title Case</td></tr><tr><td>displayGnafLot</td><td>string</td><td>("0"|"1") <br>default 1</td><td>Determines if the lot information is displayed in addresses retrieved from GNAF. </td></tr><tr><td>suppressLot</td><td>string</td><td>("0"|"1") <br>default 1</td><td>Suppresses Lot information when a street# is available in the address. If Street# is not in address then Lot information is displayed. Used when displayGnafLot = 1 and suppressLot = 1. </td></tr><tr><td>exposeAttributes</td><td>Integer</td><td>(0-7)</td><td>Enriches the data with address related attributes depending on value. Options 0,1,2,3,4,5,6,7</td></tr></tbody></table>

### Response

The response body is an [AddressRestResponse](/loqate-harmony-api/api-specification/objects/address-objects.md#addressrestresponse) object.

### Examples

All retrieves for all countries are made using the same method as above.&#x20;

Our universal fields makes country mapping core address fields easy (see guide [address field mapping](/loqate-harmony-api/guides/best-practices/address-field-mappings.md).) Depending on country and dataset the response packages do change particularly in available attributes.&#x20;

<details>

<summary>Retrieve validated: AUPAF </summary>

**Request 1:** Retrieve address AUPAF with Find ID

```json
{
        "payload": [ { "id": "AU|AUPAF|48318069" } ],
        "featureOptions":{"exposeAttributes":"1","caseType":"title"}
}
```

**Response to Request 1:** Includes DPID, Barcode and Address mapping

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "ValidatedAddressAu",
            "fullAddress": "20 Bond St, Maroubra NSW 2035",
            "country": "Australia",
            "postcode": "2035",
            "street2": null,
            "street": "Bond St",
            "streetNumber": "20",
            "postal": "",
            "postalType": "",
            "postalNumber": "",
            "buildingName": "",
            "subdwelling": "",
            "eid": null,
            "lotNumber": "",
            "flatUnitNumber": "",
            "flatUnitType": "",
            "floorLevelNumber": "",
            "floorLevelType": "",
            "streetSuffix": "",
            "streetType": "St",
            "streetName": "Bond",
            "attributes": {
                "ProvinceName": "New South Wales",
                "CountryIso2": "AU",
                "Barcode": "1301011122100122002030323310101232013",
                "CountryIso3": "AUS",
                "DPID": "48318069",
                "City": "Maroubra",
                "ProvinceCode": "NSW",
                "Bsp": "010",
                "PAFPosition": "Single"
            },
            "id": "AU|AUPAF|48318069",
            "sourceOfTruth": "AUPAF",
            "exception": null,
            "state": "NSW",
            "locality": "Maroubra"
        }
    ]
}
```

</details>

<details>

<summary>Retrieve validated: AU GNAF</summary>

**Request 1**: retrieve addresses with GNAF Source of Truth that includes address records with Lot number suppressed when Street Number exists.

* `suppressLot = 1` is the featureOption used to suppress the lot number when street number exists.&#x20;
* `displayGnafLot =1`is the featureOption that displays. 1=true. This is important for address that do not have street numbers.
* Lot number will still be displayed for the records that do not have street number. Australia only, use it with sourceOfTruth:GNAF/AUSOTS.

```json
    {
        "payload": [{"id": "AU|GNAF|GANSW705038278"}], 
        "featureOptions": { "exposeAttributes": "1", "suppressLot": "1","displayGnafLot":"1" }
    }
```

Response of **Request 1**:

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "ValidatedAddressAu",
            "fullAddress": "168 LOT STAFFORD DRIVE, KALARU NSW 2550",
            "country": "Australia",
            "postcode": "2550",
            "street2": null,
            "street": "LOT STAFFORD DRIVE",
            "streetNumber": "168",
            "postal": "",
            "postalType": "",
            "postalNumber": "",
            "buildingName": "",
            "subdwelling": "",
            "eid": null,
            "lotNumber": "",
            "flatUnitNumber": "",
            "flatUnitType": "",
            "floorLevelNumber": "",
            "floorLevelType": "",
            "streetSuffix": "",
            "streetType": "DRIVE",
            "streetName": "LOT STAFFORD",
            "attributes": {
                "GNAFGroupPID": "NSW2857737",
                "GNAFPIDPosition": "SINGLE",
                "ParcelID": "78/870178",
                "CountryIso2": "AU",
                "GNAFReliability": "2",
                "CountryIso3": "AUS",
                "GNAFConfidence": "2",
                "GNAFLocalityPID": "loc26f98008abfe",
                "Latitude": "-36.72255996",
                "City": "KALARU",
                "Longitude": "149.92348752",
                "MeshblockId": "11250630000",
                "ProvinceName": "NEW SOUTH WALES",
                "GNAFPointPID": "GANSW705038278",
                "GNAFPID": "GANSW705038278",
                "ProvinceCode": "NSW",
                "GeocodeLevel": "7"
            },
            "id": "AU|GNAF|GANSW705038278",
            "sourceOfTruth": "GNAF",
            "exception": null,
            "state": "NSW",
            "locality": "KALARU"
        }
    ]
}
```

</details>

<details>

<summary>Retrieve validated:  NZAD </summary>

**Request 3**: retrieve an New Zealand address from NZAD Source of Truth.

```json
    {
        "payload": [{"id": "NZ|NZAD|1154050"}], 
        "featureOptions": { "exposeAttributes": "1", "caseType": "TITLE" }
    }
```

Response of **Request 3**:

```json
    {
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "ValidatedAddressNz",
            "fullAddress": "Flat 20 30 Bond Street, Marton 4710",
            "country": "New Zealand",
            "postcode": "4710",
            "street2": null,
            "street": "Bond Street",
            "streetNumber": "30",
            "postal": "",
            "postalType": "",
            "postalNumber": "",
            "buildingName": "",
            "subdwelling": "Flat 20",
            "eid": null,
            "lotNumber": "",
            "flatUnitNumber": "20",
            "flatUnitType": "Flat",
            "floorLevelNumber": "",
            "floorLevelType": "",
            "streetSuffix": "",
            "streetType": "Street",
            "streetName": "Bond",
            "attributes": {
                "ParcelId": "3940629",
                "CountryIso2": "NZ",
                "address_type": "Urban",
                "CountryIso3": "NZL",
                "DPID": "1154050",
                "regional_council_id": "8",
                "Latitude": "-40.06211544305106",
                "source": "Nzpost",
                "City": "Marton",
                "Longitude": "175.3759317179828",
                "MeshblockId": "4013425",
                "ProvinceName": "Manawatu-Wanganui Region",
                "address_line2": "Marton  4710",
                "address_line1": "20/30 Bond Street",
                "regional_council_name": "Manawatu-Wanganui Region",
                "ta_name": "Rangitikei District",
                "XCoordinate": "1802635.01420514",
                "ProvinceCode": "",
                "ta_id": "38",
                "YCoordinate": "5562643.58308705"
            },
            "id": "NZ|NZAD|1154050",
            "sourceOfTruth": "NZAD",
            "rdNumber": null,
            "deliveredTo": "Y",
            "exception": null,
            "suburb": "",
            "townCity": "Marton"
        }
    ]
}
```

</details>

<details>

<summary>Retrieve validated:  CNAR</summary>

**Request 3**: retrieve an New Zealand address from NZAD Source of Truth.

```json
{
        "payload": [{ "id": "NZ|CNAR|10519716" , "country": "NZ"}]
}
```

Response of **Request 3**:

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "ValidatedAddressNz",
            "fullAddress": "10 LIVERPOOL STREET, DARGAVILLE 0310",
            "country": "New Zealand",
            "postcode": "0310",
            "street2": null,
            "street": "LIVERPOOL STREET",
            "streetNumber": "10",
            "postal": "",
            "postalType": "",
            "postalNumber": "",
            "buildingName": "",
            "subdwelling": "",
            "eid": null,
            "lotNumber": "",
            "flatUnitNumber": "",
            "flatUnitType": "",
            "floorLevelNumber": "",
            "floorLevelType": "",
            "streetSuffix": "",
            "streetType": "STREET",
            "streetName": "LIVERPOOL",
            "attributes": {
                "meshblock_id_2013": "117100",
                "CountryIso2": "NZ",
                "y_nzmg": "6582583.0",
                "complete_address": "10 LIVERPOOL STREET DARGAVILLE DARGAVILLE 0310",
                "CountryIso3": "NZL",
                "DPID": "665017",
                "l_y_nzmg": "6582583.5",
                "y_webmerc": "-4294452.442632699",
                "Latitude": "-35.95515442",
                "x_webmerc": "19354497.632800736",
                "street_number_full": "10",
                "ProvinceName": "",
                "sa1_2018": "7001035",
                "cnar_id": "10519716",
                "l_x_webmerc": "19354497.632800736",
                "x_nztm": "1677952.0",
                "addr_full": "10 LIVERPOOL STREET",
                "l_y_wgs84": "-35.9551506",
                "l_y_webmerc": "-4294451.917305179",
                "ParcelId": "4966960",
                "y_nztm": "6020680.0",
                "l_x_nzmg": "2588586.25",
                "regional_council": "NORTHLAND REGION",
                "sa2_2018": "109300",
                "l_y_nztm": "6020680.5",
                "deprivation_index": "8",
                "City": "DARGAVILLE",
                "road_id": "100000636",
                "ta": "KAIPARA DISTRICT",
                "Longitude": "173.8644104",
                "MeshblockId": "4001981",
                "l_x_wgs84": "173.8644104",
                "area_unit": "504600",
                "quintile": "4",
                "x_nzmg": "2588586.0",
                "ProvinceCode": "",
                "l_x_nztm": "1677952.75"
            },
            "id": "NZ|CNAR|10519716",
            "sourceOfTruth": "CNAR",
            "rdNumber": null,
            "exception": null,
            "suburb": "DARGAVILLE",
            "townCity": "DARGAVILLE"
        }
    ]
}
```

</details>

<details>

<summary>Retrieve validated: UK (INTL)</summary>

**Request 1**: retrieve a United Kingdom address.

```json
{
        "payload": [ { "id": "GB|RM|A|12799601|ENG" , "country": "GB"} ]
}
```

Response of **Request 1**:

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntl",
            "fullAddress": "C & L Timberkits, Unit 100, North Mersey Business Centre, Woodward Road, Knowsley Industrial Park, LIVERPOOL, L33 7UY, UNITED KINGDOM",
            "country": "United Kingdom",
            "postcode": "L33 7UY",
            "street2": "North Mersey Business Centre",
            "street": "Woodward Road",
            "streetNumber": "",
            "postal": "",
            "postalType": "",
            "postalNumber": null,
            "buildingName": "Unit 100",
            "subdwelling": "",
            "attributes": {
                "Line4": "Knowsley Industrial Park",
                "CountryIso2": "GB",
                "Company": "C & L Timberkits",
                "CountryIso3": "GBR",
                "City": "Liverpool",
                "DomesticId": "12799601",
                "DataLevel": "Premise",
                "ProvinceName": "Merseyside",
                "Type": "Commercial",
                "Language": "ENG",
                "SortingNumber1": "29142",
                "LanguageAlternatives": "ENG",
                "Barcode": "(L337UY3ZH)",
                "ProvinceCode": "",
                "CountryIsoNumber": "826",
                "Line1": "Unit 100",
                "Line2": "North Mersey Business Centre",
                "Line3": "Woodward Road",
                "AdminAreaName": "Knowsley"
            },
            "id": "GB|RM|A|12799601|ENG",
            "sourceOfTruth": null,
            "district": "Knowsley Industrial Park",
            "city": "Liverpool",
            "province": "Merseyside"
        }
    ]
}
```

</details>

<details>

<summary>Retrieve validated: USA (INTL)</summary>

**Request 1**: retrieve a United States of America address.

```json
{
        "payload": [ { "id": "US|LP|B|113264667|100_ENG" , "country": "UK"} ]
}
```

Response of **Request 1**:

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "AddressIntl",
            "fullAddress": "100 Liverpool St, EAST BOSTON MA 02128-1907, UNITED STATES",
            "country": "United States",
            "postcode": "02128-1907",
            "street2": "",
            "street": "Liverpool St",
            "streetNumber": "100",
            "postal": "",
            "postalType": "",
            "postalNumber": null,
            "buildingName": "",
            "subdwelling": "",
            "attributes": {
                "CountryIso2": "US",
                "CountryIso3": "USA",
                "City": "East Boston",
                "DomesticId": "113264667",
                "DataLevel": "Premise",
                "ProvinceName": "Massachusetts",
                "Type": "Residential",
                "Language": "ENG",
                "LanguageAlternatives": "ENG",
                "AdminAreaCode": "025",
                "ProvinceCode": "MA",
                "CountryIsoNumber": "840",
                "Line1": "100 Liverpool St",
                "AdminAreaName": "Suffolk"
            },
            "id": "US|LP|B|113264667|100_ENG",
            "sourceOfTruth": null,
            "district": "",
            "city": "East Boston",
            "province": "MA"
        }
    ]
}
```

</details>

<details>

<summary>Retrieve validated: Aust Post Parcel Locker Only</summary>

**Request 1**: retrieve AUPOST addresses

```json
    {
        "payload": [ { "id": "AU|AUPOST|RED0010639" } ], 
        "featureOptions": { "exposeAttributes": "1"}
    }
```

**Response to Request 1:**

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "ValidatedAddressAu",
            "fullAddress": "Red Street Posting Box, 10 George Street, CRANBOURNE VIC 3977",
            "country": "Australia",
            "postcode": "3977",
            "street2": null,
            "street": "George Street",
            "streetNumber": "10",
            "postal": "",
            "postalType": "",
            "postalNumber": "",
            "buildingName": "Red Street Posting Box",
            "subdwelling": "",
            "eid": null,
            "lotNumber": "",
            "flatUnitNumber": "",
            "flatUnitType": "",
            "floorLevelNumber": "",
            "floorLevelType": "",
            "streetSuffix": "",
            "streetType": "Street",
            "streetName": "George",
            "attributes": {
                "ProvinceName": "VICTORIA",
                "CountryIso2": "AU",
                "CountryIso3": "AUS",
                "name": "Red Street Posting Box",
                "address_line_1": "10 George Street",
                "Latitude": "-38.098859",
                "City": "CRANBOURNE",
                "ProvinceCode": "VIC",
                "id": "RED0010639",
                "type": "RSPB",
                "Longitude": "145.280717",
                "record_type": "spb"
            },
            "id": "AU|AUPOST|RED0010639",
            "sourceOfTruth": "AUPOST",
            "exception": null,
            "state": "VIC",
            "locality": "CRANBOURNE"
        }
    ]
}
```

</details>

<details>

<summary>Retrieve validated: Derived Address</summary>

**Request 1**: retrieve addresses with derived sub-premises enabled.

<pre class="language-json"><code class="lang-json"><strong>{
</strong>        "payload": [ { "id": "AU|GNAF|GANSW704282071|Unit 888" } ],
        "featureOptions":{"exposeAttributes":"1","caseType":"title","suppressLot":"1", "displayGnafLot":"1"}
 }

</code></pre>

**Response to Request 1:**

When sub-premise is derived we respond with the validated information eg premise level information including additional field `attributes.UserInferred` that describes the derived sub-premises.

```json
{
    "status": "SUCCESS",
    "messages": [],
    "payload": [
        {
            "_type": "ValidatedAddressAu",
            "fullAddress": "100 St Johns Road, Cabramatta NSW 2166",
            "country": "Australia",
            "postcode": "2166",
            "street2": null,
            "street": "St Johns Road",
            "streetNumber": "100",
            "postal": "",
            "postalType": "",
            "postalNumber": "",
            "buildingName": "",
            "subdwelling": "",
            "eid": null,
            "lotNumber": "",
            "flatUnitNumber": "",
            "flatUnitType": "",
            "floorLevelNumber": "",
            "floorLevelType": "",
            "streetSuffix": "",
            "streetType": "Road",
            "streetName": "St Johns",
            "attributes": {
                "GNAFGroupPID": "Nsw2916968",
                "GNAFPIDPosition": "Single",
                "ParcelID": "5/806670",
                "CountryIso2": "AU",
                "GNAFReliability": "2",
                "CountryIso3": "AUS",
                "GNAFConfidence": "2",
                "GNAFLocalityPID": "Loc49cb12b9ef21",
                "Latitude": "-33.88892945",
                "City": "Cabramatta",
                "Longitude": "150.92317213",
                "MeshblockId": "10264210000",
                "UserInferred": "Unit 888",
                "ProvinceName": "New South Wales",
                "GNAFPointPID": "Gansw704282071",
                "GNAFPID": "Gansw704282071",
                "ProvinceCode": "NSW",
                "GeocodeLevel": "7"
            },
            "id": "AU|GNAF|GANSW704282071|Unit 888",
            "sourceOfTruth": "GNAF",
            "exception": null,
            "state": "NSW",
            "locality": "Cabramatta"
        }
    ]
}
```

</details>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.mastersoftgroup.com/loqate-harmony-api/api-specification/address/address-validation-and-lookup.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
